Codeforces 16E Fish dp(概率)


题目链接:点击打开链接


题意:池中有n条鱼,每天会有两条鱼相遇,任意两条鱼两两相遇的概率相等,如果两条鱼相遇,其中一条一定会被吃掉,给出所有两两相遇时吃与被吃的概率,求每条鱼存活的概率。


状态转移方程: dp[s2]=∑(win[j][i]*dp[s]/C[num][2]);

                          i∈s

                          s2=s^i;

                          j∈s2,

起点              : dp[1<<n]=1



因为没有被吃的固定顺序,所以应该用集合表示状态。

考虑到存活的鱼两两相遇的概率相等,要用组合公式。


E. Fish
time limit per test
3 seconds
memory limit per test
128 megabytes
input
standard input
output
standard output

n fish, numbered from 1 to n, live in a lake. Every day right one pair of fish meet, and the probability of each other pair meeting is the same. If two fish with indexes i and j meet, the first will eat up the second with the probability aij, and the second will eat up the first with the probability aji = 1 - aij. The described process goes on until there are at least two fish in the lake. For each fish find out the probability that it will survive to be the last in the lake.

Input

The first line contains integer n (1 ≤ n ≤ 18) — the amount of fish in the lake. Then there follow n lines with nreal numbers each — matrix aaij (0 ≤ aij ≤ 1) — the probability that fish with index i eats up fish with index j. It's guaranteed that the main diagonal contains zeros only, and for other elements the following is true:aij = 1 - aji. All real numbers are given with not more than 6 characters after the decimal point.

Output

Output n space-separated real numbers accurate to not less than 6 decimal places. Number with index ishould be equal to the probability that fish with index i will survive to be the last in the lake.

Examples
input
2
0 0.5
0.5 0
output
0.500000 0.500000 
input
5
0 1 1 1 1
0 0 0.5 0.5 0.5
0 0.5 0 0.5 0.5
0 0.5 0.5 0 0.5
0 0.5 0.5 0.5 0
output
1.000000 0.000000 0.000000 0.000000 0.000000 



#include<cstdio>
#include<string>
#include<cstring>
#include<iostream>
#include<cmath>
#include<algorithm>
#include<vector>
using namespace std;

#define all(x) (x).begin(), (x).end()
#define for0(a, n) for (int (a) = 0; (a) < (n); (a)++)
#define for1(a, n) for (int (a) = 1; (a) <= (n); (a)++)
#define ysk(x)  (1<<(x))
typedef long long ll;
typedef pair<int, int> pii;
const int INF =0x3f3f3f3f;
const int maxn=18    ;
int ed,n;
double win[maxn+10][maxn+10];
double dp[262144+10];


int C[maxn+5][maxn+5];
void pre()
{
    C[0][0]=1;
    for(int i=1;i<=maxn;i++)
    {
        C[i][0]=C[i][i]=1;
        for(int j=1;j<i; j++)
        {
            C[i][j]=C[i-1][j-1]+C[i-1][j];
        }
    }
}

int getfishnum(int s)//统计存活的鱼的数量
{
    int ans=0;
    for0(i,n) if(s&ysk(i))
    {
        ans++;
    }
    return ans;
}
int main()
{
    pre();
    while(~scanf("%d",&n))
    {
        for0(i,n) for0(j,n) scanf("%lf",&win[i][j]);

         ed=ysk(n)-1;

         memset(dp,0,(ed+1)*sizeof dp[0]);
         dp[ed]=1;
         for(int s=ed;s>=0;s--)
         {
             int num=getfishnum(s);
             for0(i,n) if(ysk(i)&s)//枚举第一个被吃的鱼
             {
                 int s2=s^ysk(i);
                 for0(j,n) if(s2&ysk(j))//枚举吃它的鱼
                 {
                     dp[s2]+=win[j][i]*dp[s]/C[num][2];//因为任意两条鱼两两相遇的概率相等
                 }
             }

         }
         for0(i,n)
         {
             if(i)  putchar(' ');
             printf("%f",dp[ysk(i)]);
         }
         putchar('\n');



    }

   return 0;
}


区间DP是一种动态规划的方法,用于解决区间范围内的问题。在Codeforces竞赛中,区间DP经常被用于解决一些复杂的字符串或序列相关的问题。 在区间DP中,dp[i][j]表示第一个序列前i个元素和第二个序列前j个元素的最优解。具体的转移方程会根据具体的问题而变化,但是通常会涉及到比较两个序列的元素是否相等,然后根据不同的情况进行状态转移。 对于区间长度为1的情况,可以先进行初始化,然后再通过枚举区间长度和区间左端点,计算出dp[i][j]的值。 以下是一个示例代码,展示了如何使用区间DP来解决一个字符串匹配的问题: #include <cstdio> #include <cstring> #include <string> #include <iostream> #include <algorithm> using namespace std; const int maxn=510; const int inf=0x3f3f3f3f; int n,dp[maxn][maxn]; char s[maxn]; int main() { scanf("%d", &n); scanf("%s", s + 1); for(int i = 1; i <= n; i++) dp[i][i] = 1; for(int i = 1; i <= n; i++) { if(s[i] == s[i - 1]) dp[i][i - 1] = 1; else dp[i][i - 1] = 2; } for(int len = 3; len <= n; len++) { int r; for(int l = 1; l + len - 1 <= n; l++) { r = l + len - 1; dp[l][r] = inf; if(s[l] == s[r]) dp[l][r] = min(dp[l + 1][r], dp[l][r - 1]); else { for(int k = l; k <= r; k++) { dp[l][r] = min(dp[l][r], dp[l][k] + dp[k + 1][r]); } } } } printf("%d\n", dp[n]); return 0; } 希望这个例子能帮助你理解区间DP的基本思想和应用方法。如果你还有其他问题,请随时提问。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值